--- a/Data/Text/ICU/Char.hsc
+++ b/Data/Text/ICU/Char.hsc
@@ -129,6 +129,10 @@
   | PopDirectionalFormat
   | DirNonSpacingMark
   | BoundaryNeutral
+  | FirstStrongIsolate
+  | LeftToRightIsolate
+  | RightToLeftIsolate
+  | PopDirectionalIsolate
   deriving (Eq, Enum, Show, Typeable)
 
 instance NFData Direction where
@@ -357,6 +361,94 @@
   | SoraSompeng
   | SundaneseSupplement
   | Takri
+  | BassaVah
+  | CaucasianAlbanian
+  | CopticEpactNumbers
+  | CombiningDiacriticalMarksExtended
+  | Duployan
+  | Elbasan
+  | GeometricShapesExtended
+  | Grantha
+  | Khojki
+  | Khudawadi
+  | LatinExtendedE
+  | LinearA
+  | Mahajani
+  | Manichaean
+  | MendeKikakui
+  | Modi
+  | Mro
+  | MyanmarExtendedB
+  | Nabataean
+  | OldNorthArabian
+  | OldPermic
+  | OrnamentalDingbats
+  | PahawhHmong
+  | Palmyrene
+  | PauCinHau
+  | PsalterPahlavi
+  | ShorthandFormatControls
+  | Siddham
+  | SinhalaArchaicNumbers
+  | SupplementalArrowsC
+  | Tirhuta
+  | WarangCiti
+  | Ahom
+  | AnatolianHieroglyphs
+  | CherokeeSupplement
+  | CJKUnifiedIdeographsExtensionE
+  | EarlyDynasticCuneiform
+  | Hatran
+  | Multani
+  | OldHungarian
+  | SupplementalSymbolsAndPictographs
+  | SuttonSignwriting
+  | Adlam
+  | Bhaiksuki
+  | CyrillicExtendedC
+  | GlagoliticSupplement
+  | IdeographicSymbolsAndPunctuation
+  | Marchen
+  | MongolianSupplement
+  | Newa
+  | Osage
+  | Tangut
+  | TangutComponents
+  | CJKUnifiedIdeographsExtensionF
+  | KanaExtendedA
+  | MasaramGondi
+  | Nushu
+  | Soyombo
+  | SyriacSupplement
+  | ZanabazarSquare
+  | ChessSymbols
+  | Dogra
+  | GeorgianExtended
+  | GunjalaGondi
+  | HanifiRohingya
+  | IndicSiyaqNumbers
+  | Makasar
+  | MayanNumerals
+  | Medefaidrin
+  | OldSogdian
+  | Sogdian
+  | EgyptianHieroglyphFormatControls
+  | Elymaic
+  | Nandinagari
+  | NyiakengPuachueHmong
+  | OttomanSiyaqNumbers
+  | SmallKanaExtension
+  | SymbolsAndPictographsExtendedA
+  | TamilSupplement
+  | Wancho
+  | Chorasmian
+  | CjkUnifiedIdeographsExtensionG
+  | DivesAkuru
+  | KhitanSmallScript
+  | LisuSupplement
+  | SymbolsForLegacyComputing
+  | TangutSupplement
+  | Yezidi
   deriving (Eq, Enum, Bounded, Show, Typeable)
 
 instance NFData BlockCode where
